diff --git a/python/mozbuild/mozbuild/frontend/data.py b/python/mozbuild/mozbuild/frontend/data.py
index c6ed4f65ef..1ceaff3b81 100644
--- a/python/mozbuild/mozbuild/frontend/data.py
+++ b/python/mozbuild/mozbuild/frontend/data.py
@@ -15,7 +15,6 @@ contains the code for converting executed mozbuild files into these data
 structures.
 """
 
-from __future__ import absolute_import, unicode_literals
 
 from mozbuild.util import StrictOrderingOnAppendList
 from mozpack.chrome.manifest import ManifestEntry
@@ -32,7 +31,7 @@ from ..testing import (
 )
 
 
-class TreeMetadata(object):
+class TreeMetadata:
     """Base class for all data being captured."""
     __slots__ = ()
 
@@ -92,7 +91,7 @@ class ContextDerived(TreeMetadata):
         return mozpath.relpath(self.objdir, self.topobjdir)
 
 
-class HostMixin(object):
+class HostMixin:
     @property
     def defines(self):
         defines = self._context['HOST_DEFINES']
@@ -186,13 +185,13 @@ class BaseDefines(ContextDerived):
         self.defines = defines
 
     def get_defines(self):
-        for define, value in self.defines.iteritems():
+        for define, value in self.defines.items():
             if value is True:
                 yield('-D%s' % define)
             elif value is False:
                 yield('-U%s' % define)
             else:
-                yield('-D%s=%s' % (define, value))
+                yield('-D{}={}'.format(define, value))
 
     def update(self, more_defines):
         if isinstance(more_defines, Defines):
@@ -344,7 +343,7 @@ class Linkable(ContextDerived):
             raise LinkageWrongKindError(
                 'Linkable.link_library() does not take components.')
         if obj.KIND != self.KIND:
-            raise LinkageWrongKindError('%s != %s' % (obj.KIND, self.KIND))
+            raise LinkageWrongKindError('{} != {}'.format(obj.KIND, self.KIND))
         self.linked_libraries.append(obj)
         if obj.cxx_link:
             self.cxx_link = True
@@ -357,7 +356,7 @@ class Linkable(ContextDerived):
             if self.config.substs.get('GNU_CC'):
                 lib = '-l%s' % lib
             else:
-                lib = '%s%s%s' % (
+                lib = '{}{}{}'.format(
                     self.config.import_prefix,
                     lib,
                     self.config.import_suffix,
@@ -393,7 +392,7 @@ class BaseProgram(Linkable):
         self.is_unit_test = is_unit_test
 
     def __repr__(self):
-        return '<%s: %s/%s>' % (type(self).__name__, self.relobjdir, self.program)
+        return '<{}: {}/{}>'.format(type(self).__name__, self.relobjdir, self.program)
 
 
 class Program(BaseProgram):
@@ -435,7 +434,7 @@ class BaseLibrary(Linkable):
 
         self.basename = self.lib_name = basename
         if self.lib_name:
-            self.lib_name = '%s%s%s' % (
+            self.lib_name = '{}{}{}'.format(
                 context.config.lib_prefix,
                 self.lib_name,
                 context.config.lib_suffix
@@ -445,7 +444,7 @@ class BaseLibrary(Linkable):
         self.refs = []
 
     def __repr__(self):
-        return '<%s: %s/%s>' % (type(self).__name__, self.relobjdir, self.lib_name)
+        return '<{}: {}/{}>'.format(type(self).__name__, self.relobjdir, self.lib_name)
 
 
 class Library(BaseLibrary):
@@ -507,18 +506,18 @@ class SharedLibrary(Library):
         if variant == self.FRAMEWORK:
             self.import_name = self.lib_name
         else:
-            self.import_name = '%s%s%s' % (
+            self.import_name = '{}{}{}'.format(
                 context.config.import_prefix,
                 self.lib_name,
                 context.config.import_suffix,
             )
-            self.lib_name = '%s%s%s' % (
+            self.lib_name = '{}{}{}'.format(
                 context.config.dll_prefix,
                 self.lib_name,
                 context.config.dll_suffix,
             )
         if soname:
-            self.soname = '%s%s%s' % (
+            self.soname = '{}{}{}'.format(
                 context.config.dll_prefix,
                 soname,
                 context.config.dll_suffix,
@@ -541,7 +540,7 @@ class SharedLibrary(Library):
 
 
 
-class ExternalLibrary(object):
+class ExternalLibrary:
     """Empty mixin for libraries built by an external build system."""
 
 
@@ -695,7 +694,7 @@ class ContextWrapped(ContextDerived):
         self.wrapped = wrapped
 
 
-class JavaJarData(object):
+class JavaJarData:
     """Represents a Java JAR file.
 
     A Java JAR has the following members:
@@ -786,7 +785,7 @@ class UnifiedSources(BaseSources):
             unified_prefix = unified_prefix.replace('/', '_')
 
             suffix = self.canonical_suffix[1:]
-            unified_prefix='Unified_%s_%s' % (suffix, unified_prefix)
+            unified_prefix='Unified_{}_{}'.format(suffix, unified_prefix)
             self.unified_source_mapping = list(group_unified_files(source_files,
                                                                    unified_prefix=unified_prefix,
                                                                    unified_suffix=suffix,
diff --git a/python/mozbuild/mozbuild/frontend/emitter.py b/python/mozbuild/mozbuild/frontend/emitter.py
index faa41786ac..58f907469f 100644
--- a/python/mozbuild/mozbuild/frontend/emitter.py
+++ b/python/mozbuild/mozbuild/frontend/emitter.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import itertools
 import logging
@@ -117,7 +116,7 @@ class TreeMetadataEmitter(LoggingMixin):
         # rid ourselves of 2.6.
         self.info = {}
         for k, v in mozinfo.info.items():
-            if isinstance(k, unicode):
+            if isinstance(k, str):
                 k = k.encode('ascii')
             self.info[k] = v
 
@@ -135,7 +134,7 @@ class TreeMetadataEmitter(LoggingMixin):
         paths = []
         if os.path.exists(subconfigures):
             paths = open(subconfigures).read().splitlines()
-        self._external_paths = set(mozpath.normsep(d) for d in paths)
+        self._external_paths = {mozpath.normsep(d) for d in paths}
         self._emitter_time = 0.0
         self._object_count = 0
         self._test_files_converter = SupportFilesConverter()
@@ -175,7 +174,7 @@ class TreeMetadataEmitter(LoggingMixin):
                 objs = list(self.emit_from_context(out))
                 self._emitter_time += time.time() - start
 
-                for o in emit_objs(objs): yield o
+                yield from emit_objs(objs)
 
             else:
                 raise Exception('Unhandled output type: %s' % type(out))
@@ -186,7 +185,7 @@ class TreeMetadataEmitter(LoggingMixin):
             objs = list(self._emit_libs_derived(contexts))
             self._emitter_time += time.time() - start
 
-            for o in emit_objs(objs): yield o
+            yield from emit_objs(objs)
 
     def _emit_libs_derived(self, contexts):
         # First do FINAL_LIBRARY linkage.
@@ -204,8 +203,8 @@ class TreeMetadataEmitter(LoggingMixin):
             # have the library linked. The typical usecase is when building
             # both a static and a shared library in a directory, and having
             # that as a FINAL_LIBRARY.
-            if len(set(type(l) for l in candidates)) == len(candidates) and \
-                   len(set(l.objdir for l in candidates)) == 1:
+            if len({type(l) for l in candidates}) == len(candidates) and \
+                   len({l.objdir for l in candidates}) == 1:
                 for c in candidates:
                     c.link_library(lib)
             else:
@@ -223,8 +222,7 @@ class TreeMetadataEmitter(LoggingMixin):
             for o in lib.refs:
                 yield o
                 if isinstance(o, StaticLibrary):
-                    for q in recurse_refs(o):
-                        yield q
+                    yield from recurse_refs(o)
 
         # Check that all static libraries refering shared libraries in
         # USE_LIBS are linked into a shared library or program.
@@ -314,7 +312,7 @@ class TreeMetadataEmitter(LoggingMixin):
                             libs[key] = l
                         if key not in libs:
                             libs[key] = l
-                candidates = libs.values()
+                candidates = list(libs.values())
                 if force_static and not candidates:
                     if dir:
                         raise SandboxValidationError(
@@ -371,34 +369,34 @@ class TreeMetadataEmitter(LoggingMixin):
 
     def _parse_cargo_file(self, toml_file):
         """Parse toml_file and return a Python object representation of it."""
-        with open(toml_file, 'r') as f:
+        with open(toml_file) as f:
             return pytoml.load(f)
 
     def _verify_deps(self, context, crate_dir, crate_name, dependencies, description='Dependency'):
         """Verify that a crate's dependencies all specify local paths."""
-        for dep_crate_name, values in dependencies.iteritems():
+        for dep_crate_name, values in dependencies.items():
             # A simple version number.
-            if isinstance(values, (str, unicode)):
+            if isinstance(values, (str, str)):
                 raise SandboxValidationError(
-                    '%s %s of crate %s does not list a path' % (description, dep_crate_name, crate_name),
+                    '{} {} of crate {} does not list a path'.format(description, dep_crate_name, crate_name),
                     context)
 
             dep_path = values.get('path', None)
             if not dep_path:
                 raise SandboxValidationError(
-                    '%s %s of crate %s does not list a path' % (description, dep_crate_name, crate_name),
+                    '{} {} of crate {} does not list a path'.format(description, dep_crate_name, crate_name),
                     context)
 
             # Try to catch the case where somebody listed a
             # local path for development.
             if os.path.isabs(dep_path):
                 raise SandboxValidationError(
-                    '%s %s of crate %s has a non-relative path' % (description, dep_crate_name, crate_name),
+                    '{} {} of crate {} has a non-relative path'.format(description, dep_crate_name, crate_name),
                     context)
 
             if not os.path.exists(mozpath.join(context.config.topsrcdir, crate_dir, dep_path)):
                 raise SandboxValidationError(
-                    '%s %s of crate %s refers to a non-existent path' % (description, dep_crate_name, crate_name),
+                    '{} {} of crate {} refers to a non-existent path'.format(description, dep_crate_name, crate_name),
                     context)
 
     def _handle_linkables(self, context, passthru, generated_files):
@@ -667,7 +665,7 @@ class TreeMetadataEmitter(LoggingMixin):
         assert not gen_sources['UNIFIED_SOURCES']
 
         no_pgo = context.get('NO_PGO')
-        no_pgo_sources = [f for f, flags in all_flags.iteritems()
+        no_pgo_sources = [f for f, flags in all_flags.items()
                           if flags.no_pgo]
         if no_pgo:
             if no_pgo_sources:
@@ -684,17 +682,17 @@ class TreeMetadataEmitter(LoggingMixin):
         # in the definition; we'll add it in programmatically after defining
         # things.
         suffix_map = {
-            '.s': set(['.asm']),
+            '.s': {'.asm'},
             '.c': set(),
             '.m': set(),
             '.mm': set(),
-            '.cpp': set(['.cc', '.cxx']),
+            '.cpp': {'.cc', '.cxx'},
             '.S': set(),
         }
 
         # The inverse of the above, mapping suffixes to their canonical suffix.
         canonicalized_suffix_map = {}
-        for suffix, alternatives in suffix_map.iteritems():
+        for suffix, alternatives in suffix_map.items():
             alternatives.add(suffix)
             for a in alternatives:
                 canonicalized_suffix_map[a] = suffix
@@ -741,7 +739,7 @@ class TreeMetadataEmitter(LoggingMixin):
                     obj = cls(*arglist)
                     yield obj
 
-        for f, flags in all_flags.iteritems():
+        for f, flags in all_flags.items():
             if flags.flags:
                 ext = mozpath.splitext(f)[1]
                 yield PerSourceFlag(context, f, flags.flags)
@@ -772,7 +770,7 @@ class TreeMetadataEmitter(LoggingMixin):
 
         # We always emit a directory traversal descriptor. This is needed by
         # the recursive make backend.
-        for o in self._emit_directory_traversal_from_context(context): yield o
+        yield from self._emit_directory_traversal_from_context(context)
 
         for obj in self._process_xpidl(context):
             yield obj
@@ -885,7 +883,7 @@ class TreeMetadataEmitter(LoggingMixin):
         for obj in self._handle_linkables(context, passthru, generated_files):
             yield obj
 
-        generated_files.update(['%s%s' % (k, self.config.substs.get('BIN_SUFFIX', '')) for k in self._binaries.keys()])
+        generated_files.update(['{}{}'.format(k, self.config.substs.get('BIN_SUFFIX', '')) for k in self._binaries.keys()])
 
         components = []
         for var, cls in (
@@ -1033,7 +1031,7 @@ class TreeMetadataEmitter(LoggingMixin):
             script = mozpath.join(mozpath.dirname(mozpath.dirname(__file__)),
                                   'action', 'process_define_files.py')
             yield GeneratedFile(context, script, 'process_define_file',
-                                unicode(path),
+                                str(path),
                                 [Path(context, path + '.in')])
 
         generated_files = context.get('GENERATED_FILES')
@@ -1078,23 +1076,19 @@ class TreeMetadataEmitter(LoggingMixin):
     def _process_test_manifests(self, context):
         for prefix, info in TEST_MANIFESTS.items():
             for path, manifest in context.get('%s_MANIFESTS' % prefix, []):
-                for obj in self._process_test_manifest(context, info, path, manifest):
-                    yield obj
+                yield from self._process_test_manifest(context, info, path, manifest)
 
         for flavor in REFTEST_FLAVORS:
             for path, manifest in context.get('%s_MANIFESTS' % flavor.upper(), []):
-                for obj in self._process_reftest_manifest(context, flavor, path, manifest):
-                    yield obj
+                yield from self._process_reftest_manifest(context, flavor, path, manifest)
 
         for flavor in WEB_PLATFORM_TESTS_FLAVORS:
             for path, manifest in context.get("%s_MANIFESTS" % flavor.upper().replace('-', '_'), []):
-                for obj in self._process_web_platform_tests_manifest(context, path, manifest):
-                    yield obj
+                yield from self._process_web_platform_tests_manifest(context, path, manifest)
 
         python_tests = context.get('PYTHON_UNIT_TESTS')
         if python_tests:
-            for obj in self._process_python_tests(context, python_tests):
-                yield obj
+            yield from self._process_python_tests(context, python_tests)
 
     def _process_test_manifest(self, context, info, manifest_path, mpmanifest):
         flavor, install_root, install_subdir, package_tests = info
diff --git a/python/mozbuild/mozbuild/frontend/gyp_reader.py b/python/mozbuild/mozbuild/frontend/gyp_reader.py
index e6d2607032..af9c0c22a1 100644
--- a/python/mozbuild/mozbuild/frontend/gyp_reader.py
+++ b/python/mozbuild/mozbuild/frontend/gyp_reader.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
 import gyp
 import gyp.msvs_emulation
@@ -42,18 +41,19 @@ script_dir = mozpath.join(chrome_src, 'build')
 
 
 def encode(value):
-    if isinstance(value, unicode):
-        return value.encode('utf-8')
+    # Python 3: gyp expects plain str, not bytes
+    if isinstance(value, bytes):
+        return value.decode('utf-8')
     return value
 
 
 # Default variables gyp uses when evaluating gyp files.
 generator_default_variables = {
 }
-for dirname in [b'INTERMEDIATE_DIR', b'SHARED_INTERMEDIATE_DIR', b'PRODUCT_DIR',
-                b'LIB_DIR', b'SHARED_LIB_DIR']:
+for dirname in ['INTERMEDIATE_DIR', 'SHARED_INTERMEDIATE_DIR', 'PRODUCT_DIR',
+                'LIB_DIR', 'SHARED_LIB_DIR']:
   # Some gyp steps fail if these are empty(!).
-  generator_default_variables[dirname] = b'$' + dirname
+  generator_default_variables[dirname] = '$' + dirname
 
 for unused in ['RULE_INPUT_PATH', 'RULE_INPUT_ROOT', 'RULE_INPUT_NAME',
                'RULE_INPUT_DIRNAME', 'RULE_INPUT_EXT',
@@ -61,7 +61,7 @@ for unused in ['RULE_INPUT_PATH', 'RULE_INPUT_ROOT', 'RULE_INPUT_NAME',
                'STATIC_LIB_PREFIX', 'STATIC_LIB_SUFFIX',
                'SHARED_LIB_PREFIX', 'SHARED_LIB_SUFFIX',
                'LINKER_SUPPORTS_ICF']:
-  generator_default_variables[unused] = b''
+  generator_default_variables[unused] = ''
 
 
 class GypContext(TemplateContext):
@@ -122,7 +122,7 @@ def read_from_gyp(config, path, output, vars, no_chromium, no_unified, action_ov
     # gyp expects plain str instead of unicode. The frontend code gives us
     # unicode strings, so convert them.
     path = encode(path)
-    str_vars = dict((name, encode(value)) for name, value in vars.items())
+    str_vars = {name: encode(value) for name, value in vars.items()}
     if is_msvc:
         # This isn't actually used anywhere in this generator, but it's needed
         # to override the registry detection of VC++ in gyp.
@@ -130,10 +130,10 @@ def read_from_gyp(config, path, output, vars, no_chromium, no_unified, action_ov
         os.environ['GYP_MSVS_VERSION'] = config.substs['MSVS_VERSION']
 
     params = {
-        b'parallel': False,
-        b'generator_flags': {},
-        b'build_files': [path],
-        b'root_targets': None,
+        'parallel': False,
+        'generator_flags': {},
+        'build_files': [path],
+        'root_targets': None,
     }
 
     if no_chromium:
@@ -149,7 +149,7 @@ def read_from_gyp(config, path, output, vars, no_chromium, no_unified, action_ov
 
     # Read the given gyp file and its dependencies.
     generator, flat_list, targets, data = \
-        gyp.Load([path], format=b'mozbuild',
+        gyp.Load([path], format='mozbuild',
             default_variables=str_vars,
             includes=includes,
             depth=encode(depth),
@@ -158,7 +158,7 @@ def read_from_gyp(config, path, output, vars, no_chromium, no_unified, action_ov
     # Process all targets from the given gyp files and its dependencies.
     # The path given to AllTargets needs to use os.sep, while the frontend code
     # gives us paths normalized with forward slash separator.
-    for target in gyp.common.AllTargets(flat_list, targets, path.replace(b'/', os.sep)):
+    for target in gyp.common.AllTargets(flat_list, targets, path.replace('/', os.sep)):
         build_file, target_name, toolset = gyp.common.ParseQualifiedTarget(target)
 
         # Each target is given its own objdir. The base of that objdir
@@ -169,7 +169,7 @@ def read_from_gyp(config, path, output, vars, no_chromium, no_unified, action_ov
         # and the target_name.
         reldir  = mozpath.relpath(mozpath.dirname(build_file),
                                   mozpath.dirname(path))
-        subdir = '%s_%s' % (
+        subdir = '{}_{}'.format(
             mozpath.splitext(mozpath.basename(build_file))[0],
             target_name,
         )
@@ -234,10 +234,10 @@ def read_from_gyp(config, path, output, vars, no_chromium, no_unified, action_ov
             if spec['type'] in ('static_library', 'shared_library'):
                 if name.startswith('lib'):
                     name = name[3:]
-                # The context expects an unicode string.
-                context['LIBRARY_NAME'] = name.decode('utf-8')
+                # The context expects a unicode string.
+                context['LIBRARY_NAME'] = name if isinstance(name, str) else name.decode('utf-8')
             else:
-                context['PROGRAM'] = name.decode('utf-8')
+                context['PROGRAM'] = name if isinstance(name, str) else name.decode('utf-8')
             if spec['type'] == 'shared_library':
                 context['FORCE_SHARED_LIB'] = True
             elif spec['type'] == 'static_library' and spec.get('variables', {}).get('no_expand_libs', '0') == '1':
@@ -343,7 +343,7 @@ def read_from_gyp(config, path, output, vars, no_chromium, no_unified, action_ov
                         if not f:
                             continue
                         # the result may be a string or a list.
-                        if isinstance(f, types.StringTypes):
+                        if isinstance(f, (str,)):
                             context[var].append(f)
                         else:
                             context[var].extend(f)
diff --git a/python/mozbuild/mozbuild/frontend/mach_commands.py b/python/mozbuild/mozbuild/frontend/mach_commands.py
index cbecc11375..6d8b56b799 100644
--- a/python/mozbuild/mozbuild/frontend/mach_commands.py
+++ b/python/mozbuild/mozbuild/frontend/mach_commands.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
+from __future__ import print_function
 from collections import defaultdict
 import os
 
@@ -72,7 +72,7 @@ class MozbuildFileCommands(MachCommandBase):
                         print(line)
                     continue
 
-                print('Could not find symbol: %s' % s)
+                print(('Could not find symbol: %s' % s))
                 return 1
 
             return 0
@@ -108,13 +108,13 @@ class MozbuildFileCommands(MachCommandBase):
             for p, m in self._get_files_info(paths, rev=rev).items():
                 components[m.get('BUG_COMPONENT')].add(p)
         except InvalidPathException as e:
-            print(e.message)
+            print((e.message))
             return 1
 
-        for component, files in sorted(components.items(), key=lambda x: (x is None, x)):
-            print('%s :: %s' % (component.product, component.component) if component else 'UNKNOWN')
+        for component, files in sorted(list(components.items()), key=lambda x: (x is None, x)):
+            print(('{} :: {}'.format(component.product, component.component) if component else 'UNKNOWN'))
             for f in sorted(files):
-                print('  %s' % f)
+                print(('  %s' % f))
 
     @SubCommand('file-info', 'missing-bugzilla',
                 'Show files missing Bugzilla component info')
@@ -128,7 +128,7 @@ class MozbuildFileCommands(MachCommandBase):
                 if 'BUG_COMPONENT' not in m:
                     print(p)
         except InvalidPathException as e:
-            print(e.message)
+            print((e.message))
             return 1
 
     @SubCommand('file-info', 'dep-tests',
@@ -140,22 +140,22 @@ class MozbuildFileCommands(MachCommandBase):
     def file_info_test_deps(self, paths, rev=None):
         try:
             for p, m in self._get_files_info(paths, rev=rev).items():
-                print('%s:' % mozpath.relpath(p, self.topsrcdir))
+                print(('%s:' % mozpath.relpath(p, self.topsrcdir)))
                 if m.test_files:
                     print('\tTest file patterns:')
                     for p in m.test_files:
-                        print('\t\t%s' % p)
+                        print(('\t\t%s' % p))
                 if m.test_tags:
                     print('\tRelevant tags:')
                     for p in m.test_tags:
-                        print('\t\t%s' % p)
+                        print(('\t\t%s' % p))
                 if m.test_flavors:
                     print('\tRelevant flavors:')
                     for p in m.test_flavors:
-                        print('\t\t%s' % p)
+                        print(('\t\t%s' % p))
 
         except InvalidPathException as e:
-            print(e.message)
+            print((e.message))
             return 1
 
 
diff --git a/python/mozbuild/mozbuild/frontend/reader.py b/python/mozbuild/mozbuild/frontend/reader.py
index 165a8b7119..1bdec721a0 100644
--- a/python/mozbuild/mozbuild/frontend/reader.py
+++ b/python/mozbuild/mozbuild/frontend/reader.py
@@ -16,7 +16,6 @@ The BuildReader contains basic logic for traversing a tree of mozbuild files.
 It does this by examining specific variables populated during execution.
 """
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import ast
 import inspect
@@ -81,19 +80,15 @@ from .context import (
 from mozbuild.base import ExecutionSummary
 
 
-if sys.version_info.major == 2:
-    text_type = unicode
-    type_type = types.TypeType
-else:
-    text_type = str
-    type_type = type
+text_type = str
+type_type = type
 
 
 def log(logger, level, action, params, formatter):
     logger.log(level, formatter, extra={'action': action, 'params': params})
 
 
-class EmptyConfig(object):
+class EmptyConfig:
     """A config object that is empty.
 
     This config object is suitable for using with a BuildReader on a vanilla
@@ -309,11 +304,11 @@ class MozbuildSandbox(Sandbox):
             raise Exception('`template` is a function decorator. You must '
                 'use it as `@template` preceding a function declaration.')
 
-        name = func.func_name
+        name = func.__name__
 
         if name in self.templates:
             raise KeyError(
-                'A template named "%s" was already declared in %s.' % (name,
+                'A template named "{}" was already declared in {}.'.format(name,
                 self.templates[name].path))
 
         if name.islower() or name.isupper() or name[0].islower():
@@ -403,12 +398,12 @@ class MozbuildSandbox(Sandbox):
         return template_wrapper
 
 
-class TemplateFunction(object):
+class TemplateFunction:
     def __init__(self, func, sandbox):
-        self.path = func.func_code.co_filename
-        self.name = func.func_name
+        self.path = func.__code__.co_filename
+        self.name = func.__name__
 
-        code = func.func_code
+        code = func.__code__
         firstlineno = code.co_firstlineno
         lines = sandbox._current_source.splitlines(True)
         lines = inspect.getblock(lines[firstlineno - 1:])
@@ -428,7 +423,7 @@ class TemplateFunction(object):
         # actually never calls __getitem__ and __setitem__, so we need to
         # modify the AST so that accesses to globals are properly directed
         # to a dict.
-        self._global_name = b'_data' # AST wants str for this, not unicode
+        self._global_name = '_data' # AST wants str for this
         # In case '_data' is a name used for a variable in the function code,
         # prepend more underscores until we find an unused name.
         while (self._global_name in code.co_names or
@@ -447,8 +442,8 @@ class TemplateFunction(object):
             compile(func_ast, self.path, 'exec'),
             glob,
             self.name,
-            func.func_defaults,
-            func.func_closure,
+            func.__defaults__,
+            func.__closure__,
         )
         func()
 
@@ -462,11 +457,11 @@ class TemplateFunction(object):
             '__builtins__': sandbox._builtins
         }
         func = types.FunctionType(
-            self._func.func_code,
+            self._func.__code__,
             glob,
             self.name,
-            self._func.func_defaults,
-            self._func.func_closure
+            self._func.__defaults__,
+            self._func.__closure__
         )
         sandbox.exec_function(func, args, kwargs, self.path,
                               becomes_current_path=False)
@@ -481,8 +476,8 @@ class TemplateFunction(object):
 
         def visit_Str(self, node):
             # String nodes we got from the AST parser are str, but we want
-            # unicode literals everywhere, so transform them.
-            node.s = unicode(node.s)
+            # str literals everywhere, so transform them.
+            node.s = str(node.s)
             return node
 
         def visit_Name(self, node):
@@ -511,7 +506,7 @@ class SandboxValidationError(Exception):
         s = StringIO()
 
         delim = '=' * 30
-        s.write('\n%s\nERROR PROCESSING MOZBUILD FILE\n%s\n\n' % (delim, delim))
+        s.write('\n{}\nERROR PROCESSING MOZBUILD FILE\n{}\n\n'.format(delim, delim))
 
         s.write('The error occurred while processing the following file or ')
         s.write('one of the files it includes:\n')
@@ -585,7 +580,7 @@ class BuildReaderError(Exception):
         s = StringIO()
 
         delim = '=' * 30
-        s.write('\n%s\nERROR PROCESSING MOZBUILD FILE\n%s\n\n' % (delim, delim))
+        s.write('\n{}\nERROR PROCESSING MOZBUILD FILE\n{}\n\n'.format(delim, delim))
 
         s.write('The error occurred while processing the following file:\n')
         s.write('\n')
@@ -615,7 +610,7 @@ class BuildReaderError(Exception):
 
             for l in traceback.format_exception(type(self.other), self.other,
                 self.trace):
-                s.write(unicode(l))
+                s.write(str(l))
 
         return s.getvalue()
 
@@ -828,7 +823,7 @@ class BuildReaderError(Exception):
         s.write('    %s\n' % traceback.format_exception_only(type(e), e))
 
 
-class BuildReader(object):
+class BuildReader:
     """Read a tree of mozbuild files into data structures.
 
     This is where the build system starts. You give it a tree configuration
@@ -1029,9 +1024,8 @@ class BuildReader(object):
         """
         self._execution_stack.append(path)
         try:
-            for s in self._read_mozbuild(path, config, descend=descend,
-                                         metadata=metadata):
-                yield s
+            yield from self._read_mozbuild(path, config, descend=descend,
+                                         metadata=metadata)
 
         except BuildReaderError as bre:
             raise bre
@@ -1129,7 +1123,7 @@ class BuildReader(object):
                         context)
                 non_unified_sources.add(source)
             action_overrides = {}
-            for action, script in gyp_dir.action_overrides.iteritems():
+            for action, script in gyp_dir.action_overrides.items():
                 action_overrides[action] = SourcePath(context, script)
             time_start = time.time()
             for gyp_context in read_from_gyp(context.config,
@@ -1150,8 +1144,7 @@ class BuildReader(object):
             context['DIRS'].append(mozpath.relpath(gyp_context.objdir, context.objdir))
             sandbox.subcontexts.append(gyp_context)
 
-        for subcontext in sandbox.subcontexts:
-            yield subcontext
+        yield from sandbox.subcontexts
 
         # Traverse into referenced files.
 
@@ -1188,9 +1181,8 @@ class BuildReader(object):
             if not descend:
                 continue
 
-            for res in self.read_mozbuild(child_path, context.config,
-                                          metadata=child_metadata):
-                yield res
+            yield from self.read_mozbuild(child_path, context.config,
+                                          metadata=child_metadata)
 
         self._execution_stack.pop()
 
